//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
// ArithmeticDriver.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

//void TestDispatchArithmetic()
//{
//	CComPtr<Arithmetic::IBasicOperations> a;
//	HRESULT hr = a.CoCreateInstance(__uuidof(Arithmetic::Arithmetic));
//	if(FAILED(hr))
//		return;
//
//	DISPPARAMS dispparams;
//	memset(&dispparams, 0, sizeof(dispparams));
//	dispparams.cArgs = 2;
//	// Allocate memory for parameters
//	VARIANTARG* pArg = new VARIANTARG[dispparams.cArgs];
//	dispparams.rgvarg = pArg;
//	memset(pArg, 0, sizeof(VARIANT) * dispparams.cArgs);
//
//	// The parameters are entered right to left;
//	dispparams.rgvarg[0].vt = VT_I4;
//	dispparams.rgvarg[0].lVal = 2;
//	dispparams.rgvarg[1].vt = VT_I4;
//	dispparams.rgvarg[1].lVal = 2;
//
//    VARIANTARG varRet;
//	VariantInit( &varRet );
//
//	DISPID id[4];
//	OLECHAR *szMember = L"Add";
//	hr = a->GetIDsOfNames(IID_NULL, &szMember, 1, LOCALE_SYSTEM_DEFAULT, &id[0]);
//	szMember = L"Subtract";
//	hr = a->GetIDsOfNames(IID_NULL, &szMember, 1, LOCALE_SYSTEM_DEFAULT, &id[1]);
//	szMember = L"Multiply";
//	hr = a->GetIDsOfNames(IID_NULL, &szMember, 1, LOCALE_SYSTEM_DEFAULT, &id[2]);
//	szMember = L"Divide";
//	hr = a->GetIDsOfNames(IID_NULL, &szMember, 1, LOCALE_SYSTEM_DEFAULT, &id[3]);
//
//	hr = a->Invoke(id[0], IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &dispparams, &varRet, NULL, NULL);
//	hr = a->Invoke(id[1], IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &dispparams, &varRet, NULL, NULL);
//	hr = a->Invoke(id[2], IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &dispparams, &varRet, NULL, NULL);
//	hr = a->Invoke(id[3], IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &dispparams, &varRet, NULL, NULL);
//}
void TestInterfaceArithmetic()
{
	CComPtr<Arithmetic::IBasicOperations> a;
	HRESULT hr = a.CoCreateInstance(__uuidof(Arithmetic::Arithmetic));
	if(FAILED(hr))
		return;
	CComQIPtr<Arithmetic::IBasicOperations> i = a;
	int result;
	result = i->Add(2,3);
	result = i->Subtract(4,3);
	result = i->Multiply(2,5);
	result = i->Divide(10,2);
}
int _tmain(int argc, _TCHAR* argv[])
{
	CoInitialize(NULL);
	// TestDispatchArithmetic();
	TestInterfaceArithmetic();
	CoUninitialize();
	return 0;
}

